




//
//
// Prandtl Meyer Expansion Wave Solver, based on Anderssons book.
//
// Written in February/March 2003, by Maciej Matyka.
// I do not get any responsibility for anything.
//
//
//
// Feel free to use/copy/rewrite.
//
// For version with animation output, write to me:
//
// maq@panoramix.ift.uni.wroc.pl
//
//
// Maciej Matyka, Linkoping, 12.III.2003
// http://panoramix.ift.uni.wroc.pl/~maq
//



#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <iostream>

#include "ExpansionWave.h"
#include "minmax.h"
#include "visual.h"
#include "view.h"

//using namespace std;

struct GridPoint g[NX+1][NY+1];		// main grid (computational one)
double f_act;						// for pm function

double mtheta=6;//5.352f;		// mtheta angle in radians



void put(char *s)
{
	cout << s << endl;
}

void export_textable(void)
{
	int j;

		//cout << "i: " << i << "  x:  " << x << endl << endl; 

		cout << "\begin{table}[h]" << endl;
		cout << "\centering" << endl;
		cout << "\begin{tabular}{|c|c|c|c|c|}" << endl;
		cout << "% after \\: \hline or \cline{col1-col2} \cline{col3-col4} ..." << endl;
		cout << "  \hline" << endl;

 /*   kolor & 1 cyfra & 2 cyfra & potga dziesitna & tolerancja
    $()=$b. rzadko \\ \hline\hline
    czarny & 0 & 0 & $10^{0}$ & $\pm 20$\\ \hline
    brzowy & 1 & 1 & $10^{1}$ & $\pm (1)$\\ \hline
    czerwony & 2 & 2 & $10^{2}$ & $\pm (2)$\\ \hline
    pomaraczowy & 3 & 3 & $10^{3}$ & $\pm (3)$\\ \hline
    ty & 4 & 4 & $10^{4}$ & $\pm (4)$\\ \hline
    zielony & 5 & 5 & $10^{5}$ & $\pm (5)$\\ \hline
    niebieski & 6 & 6 & $10^{6}$ & $\pm (6)$\\ \hline
    fioletowy & 7 & 7 & $10^{7}$ & $\pm (7)$\\ \hline
    szary & 8 & 8 & $10^{-2}$ & $\pm (8)$\\ \hline
    biay & 9 & 9 & $10^{-1}$ & $\pm (9)$\\ \hline
    zoty & - & - & $10^{-1}$ & $\pm 5$\\ \hline
    srebrny & - & - & $10^{-2}$ & $\pm 10$\\ \hline
    bez koloru & - & - & - & $\pm 20$\\ \hline

\end{tabular}
\caption{Kod kolorowy opornikw.}
 \end{table}

*/
		for(j=1;j<=NY;j++)
		{
			//cout << y(x,j) << "  ,  " << g[i][j].u << "  ,  " << g[i][j].v << "  ,  ";
//			//cout << "  ,  " << g[i][j].rho << "  ,  " << g[i][j].t << "  ,  " << g[i][j].p << "  ,  " ;
			//cout << g[i][j].m << "  ,  " << dk << endl;
		}

}





int main(void)
{
	int	i,j;
	double x;				// starting point
	double dk;				// dksi step size

	double width,height;	// visualize

	x=0;					// starting point
	i=0;
	dk=0;

	initial_values(678.1,0,1.23,101000,286,2);
	

	for(j=1;j<=NY;j++)
		encode(i,j);		// obtain F1-4, G1-4


	for(i=0,x=0;i<=NX-1;i++)
	{
		//cout << endl << endl << endl;

		predictor_step_pre(x,i);	// calculation of mi,dmidx
		dk=calculate_dksi(x,i);		// calculate step size

	////cout << "starting predictor_step_1(x,i,j,g[i][2].mi-g[i][1].mi,dk);.";
	//	//cout << g[i][2].mi-g[i][1].mi << endl;


		for(j=1;j<=NY;j++)
		{
			g[i][j].y=y(x,j);
			g[i][j].ys=ys(x);
		}


		for(j=1;j<=NY;j++)
			predictor_step_1(x,i,j,g[i][2].mi-g[i][1].mi,dk);
		////cout << ".. done" << endl;
	
		////cout << "starting predictor_decode_rho(i,j)";
		for(j=1;j<=NY;j++)
			predictor_decode_rho(i,j);
		////cout << ".. done" << endl;
	
		////cout << "starting predictor_encode_g(i,j)";
		for(j=1;j<=NY;j++)
			predictor_encode_g(i,j);
		////cout << ".. done" << endl;

		////cout << "starting corrector_step_1(x,i,j,g[i][2].mi-g[i][1].mi,dk);";
		for(j=1;j<=NY;j++)
			corrector_step_1(x,i,j,g[i][2].mi-g[i][1].mi,dk);		// find dfdkp1-4, and pp
		////cout << ".. done" << endl;
	
		////cout << "starting corrector_step_2(i,j,dk);.";
		for(j=1;j<=NY;j++)
			corrector_step_2(i,j,dk);								// finally F1-4
		////cout << ".. done" << endl;


		////cout << "starting corrector_encode_physcis(i,j);.";
		for(j=2;j<=NY;j++)
			corrector_encode_physcis(i,j);
		////cout << ".. done" << endl;

		// left j=1 point boundary	

		////cout << "starting abbett.";

		abbett(x,i);

		////cout << ".. done" << endl;

		
		x+=dk;

	}



/*	height = NY+fabs(g[NX-2][1].ys);
	width = NX;

	V_OpenView(width,j);

//	V_ClearRect(1,1,width-1,height-1);


//	PlotParticles(NX,NY,g);
	PlotParticlesPhysics(width,height,NX,NY,g);
//	PlotVelocities(NX*5,NY*5,NX,NY,5,5,g);
	V_Write(1);


	V_CloseView();
*/

	return 0;
}





// Apply Initial values to x0=0 vertical line
//
//
//
//

void initial_values(double u, double v, double rho, double p, double t, double m)
{
	int j;
	for(j=1;j<=NY;j++)		// j=[1;41]
	{
		g[0][j].u = u;		// m/s
		g[0][j].v = v;			// m/s
		g[0][j].rho = rho;		// kg/m^3
		g[0][j].p = p;		// N/m^2
		g[0][j].t = t;		// K (Kelwin)
		g[0][j].m = m;			// Mach Number
		g[0][j].miu=RTD*(asin(1.0f/g[0][j].m));
	}
}




// eq. 8.6a-e, 8.7a-e
// p. 378, 379
//
// encode F1-F4, G1-G4
//

void encode(int i, int j)
{
 g[i][j].F1 = g[i][j].rho * g[i][j].u;
 g[i][j].F2 = g[i][j].rho * pow( g[i][j].u, 2) + g[i][j].p;
 g[i][j].F3 = g[i][j].rho * g[i][j].u * g[i][j].v;
 g[i][j].F4 = g[i][j].rho * g[i][j].u * (pow(g[i][j].u,2)+pow(g[i][j].v,2))/2.0f + (gamma/(gamma-1))*g[i][j].p * g[i][j].u;
	
 g[i][j].G1 = g[i][j].rho * g[i][j].v;
 g[i][j].G2 = g[i][j].rho * g[i][j].u*g[i][j].v;
 g[i][j].G3 = g[i][j].rho * pow(g[i][j].v,2)+g[i][j].p;
 g[i][j].G4 = g[i][j].rho * g[i][j].v*(pow(g[i][j].u,2)+pow(g[i][j].v,2))/2.0f + (gamma/(gamma-1))*g[i][j].p*g[i][j].v;
}




// h(x) function - 8.34, 8.35, page 385
//
//
//
// global uses: M_E expansion corner position

double h(double x)
{
	if(x<M_E)
		return H0;				// defined in header file
	else
		return(H0 + (x-M_E)*tan(DTR*mtheta));
}


// ys(x) function - page 384
// 
//
// return: surface position
// global uses: M_E expansion corner position

double ys(double x)
{
	if(x<M_E)
		return 0;
	else
		return(-(x-M_E)*tan(DTR*mtheta));
}


// y(x) function - my own
// 
//
// return: y position in physics grid
// global uses: NY, h(x), ys(x)

double y(double x, int j)
{
	return((float)(j-1)/(NY-1))*h(x)+ys(x);
}




void predictor_step_pre(double x, int i)
{
	int j;	

// compute mi for vertical line
//
// page 383, equation 8.20
//
// calculate mi(x,y) (= Mi[x][j])
//

	for(j=1;j<=NY;j++)			// 1-41
		g[i][j].mi=(y(x,j)-ys(x))/h(x);


//
// page 384, equation 8.25a,b
//
// calculate dmidx(x,y) (= dmidx[i][j])
//

	for(j=1;j<=NY;j++)			// 1-41
	if(x<M_E)
		g[i][j].dmidx=0;
	else
		g[i][j].dmidx=(1-g[i][j].mi)*tan(DTR*mtheta)/h(x);
}


//
// Calculate dksi values of step size for 
//
//
//
//
//

double calculate_dksi(double x, int i)
{
	double maximum;
	int j;

	maximum=0;		// start at 0

	for(j=1;j<=NY;j++)
		maximum=max( fabs(tan(DTR*(mtheta+g[i][j].miu))), maximum);

	for(j=1;j<=NY;j++)
		maximum=max( fabs(tan(DTR*(mtheta-g[i][j].miu))), maximum);

	return((Courant*(y(x,2)-y(x,1)))/maximum);
}


//
// first step of predictor, calculate the dfdk,sf and finally the Fp values
//

void predictor_step_1(double x, int i, int j, double dmi, double dk)
{

	// first, check if it is a boundary
	if(j==1)
	{
		// 8.36 a-d
		// 
		//
		// apply predictor step		(loop)
		// 
	
		g[i][j].dF1dk = g[i][j].dmidx * (( g[i][j+1].F1-g[i][j].F1)/dmi)+(1.0f/h(x))*((g[i][j+1].G1 - g[i][j].G1)/dmi);
		g[i][j].dF2dk = g[i][j].dmidx * (( g[i][j+1].F2-g[i][j].F2)/dmi)+(1.0f/h(x))*((g[i][j+1].G2 - g[i][j].G2)/dmi);
		g[i][j].dF3dk = g[i][j].dmidx * (( g[i][j+1].F3-g[i][j].F3)/dmi)+(1.0f/h(x))*((g[i][j+1].G3 - g[i][j].G3)/dmi);
		g[i][j].dF4dk = g[i][j].dmidx * (( g[i][j+1].F4-g[i][j].F4)/dmi)+(1.0f/h(x))*((g[i][j+1].G4 - g[i][j].G4)/dmi);

		// 8.37 a-d
		// 
		//
		// calculate predicted values of F (=Fp[][]) - with artifical viscosity
		//
		
		g[i+1][j].F1p = g[i][j].F1 + g[i][j].dF1dk * dk;
		g[i+1][j].F2p = g[i][j].F2 + g[i][j].dF2dk * dk;
		g[i+1][j].F3p = g[i][j].F3 + g[i][j].dF3dk * dk;
		g[i+1][j].F4p = g[i][j].F4 + g[i][j].dF4dk * dk;

	} else if(j==NY)
	{
		// 8.36 a-d
		// 
		//
		// apply predictor step		(loop)
		// 
	
		g[i][j].dF1dk = g[i][j].dmidx * (( g[i][j-1].F1-g[i][j].F1)/dmi)+(1.0f/h(x))*((g[i][j-1].G1 - g[i][j].G1)/dmi);
		g[i][j].dF2dk = g[i][j].dmidx * (( g[i][j-1].F2-g[i][j].F2)/dmi)+(1.0f/h(x))*((g[i][j-1].G2 - g[i][j].G2)/dmi);
		g[i][j].dF3dk = g[i][j].dmidx * (( g[i][j-1].F3-g[i][j].F3)/dmi)+(1.0f/h(x))*((g[i][j-1].G3 - g[i][j].G3)/dmi);
		g[i][j].dF4dk = g[i][j].dmidx * (( g[i][j-1].F4-g[i][j].F4)/dmi)+(1.0f/h(x))*((g[i][j-1].G4 - g[i][j].G4)/dmi);
	
		// 8.37 a-d
		// 
		//
		// calculate predicted values of F (=Fp[][]) - with artifical viscosity
		//
		
		g[i+1][j].F1p = g[i][j].F1 + g[i][j].dF1dk * dk;
		g[i+1][j].F2p = g[i][j].F2 + g[i][j].dF2dk * dk;
		g[i+1][j].F3p = g[i][j].F3 + g[i][j].dF3dk * dk;
		g[i+1][j].F4p = g[i][j].F4 + g[i][j].dF4dk * dk;
	}
	else
	{
	
		// 8.36 a-d
		// 
		//
		// apply predictor step		(loop)
		// 
	
		g[i][j].dF1dk = g[i][j].dmidx * (( g[i][j].F1-g[i][j+1].F1)/dmi)+(1.0f/h(x))*((g[i][j].G1 - g[i][j+1].G1)/dmi);
		g[i][j].dF2dk = g[i][j].dmidx * (( g[i][j].F2-g[i][j+1].F2)/dmi)+(1.0f/h(x))*((g[i][j].G2 - g[i][j+1].G2)/dmi);
		g[i][j].dF3dk = g[i][j].dmidx * (( g[i][j].F3-g[i][j+1].F3)/dmi)+(1.0f/h(x))*((g[i][j].G3 - g[i][j+1].G3)/dmi);
		g[i][j].dF4dk = g[i][j].dmidx * (( g[i][j].F4-g[i][j+1].F4)/dmi)+(1.0f/h(x))*((g[i][j].G4 - g[i][j+1].G4)/dmi);
	
	
		// 8.46a-b (c-d by myself)
		// 
		//
		// calculate predicted values for artifical viscosity (not dashed, without |p)
		//
			
		g[i][j].SF1 = (Cy*fabs( g[i][j+1].p - 2*g[i][j].p + g[i][j-1].p) / (g[i][j+1].p + 2*g[i][j].p + g[i][j-1].p)) * (g[i][j+1].F1 - 2*g[i][j].F1 + g[i][j-1].F1);
		g[i][j].SF2 = (Cy*fabs( g[i][j+1].p - 2*g[i][j].p + g[i][j-1].p) / (g[i][j+1].p + 2*g[i][j].p + g[i][j-1].p)) * (g[i][j+1].F2 - 2*g[i][j].F2 + g[i][j-1].F2);
		g[i][j].SF3 = (Cy*fabs( g[i][j+1].p - 2*g[i][j].p + g[i][j-1].p) / (g[i][j+1].p + 2*g[i][j].p + g[i][j-1].p)) * (g[i][j+1].F3 - 2*g[i][j].F3 + g[i][j-1].F3);
		g[i][j].SF4 = (Cy*fabs( g[i][j+1].p - 2*g[i][j].p + g[i][j-1].p) / (g[i][j+1].p + 2*g[i][j].p + g[i][j-1].p)) * (g[i][j+1].F4 - 2*g[i][j].F4 + g[i][j-1].F4);
	
	
		// 8.37 a-d
		// 
		//
		// calculate predicted values of F (=Fp[][]) - with artifical viscosity
		//
		
		g[i+1][j].F1p = g[i][j].F1 + g[i][j].dF1dk * dk + g[i][j].SF1;
		g[i+1][j].F2p = g[i][j].F2 + g[i][j].dF2dk * dk + g[i][j].SF2;
		g[i+1][j].F3p = g[i][j].F3 + g[i][j].dF3dk * dk + g[i][j].SF3;
		g[i+1][j].F4p = g[i][j].F4 + g[i][j].dF4dk * dk + g[i][j].SF4;
	
	}
	
}

//
// decode the predicted value of rho, and then predicted
// values of G1-G4
//
//
//

void predictor_decode_rho(int i, int j)
{
	double A,B,C;

	A=pow(g[i+1][j].F3p,2) / (2*g[i+1][j].F1p) - g[i+1][j].F4p;
	B=(gamma/(gamma-1)) * g[i+1][j].F1p * g[i+1][j].F2p;
	C=-((gamma+1)/(2*gamma-2)) * pow(g[i+1][j].F1p,3);

	g[i+1][j].rhop = (-B + sqrt(pow(B,2)-4*A*C)) / (2*A);
}


// 8.39 - 8.42
// 
//
// calculate predicted values of G (=Gp[][])
//

void predictor_encode_g(int i, int j)
{
	g[i+1][j].G1p = g[i+1][j].rhop * (g[i+1][j].F3p/g[i+1][j].F1p);
	g[i+1][j].G2p = g[i+1][j].F3p;
	g[i+1][j].G3p = g[i+1][j].rhop * pow((g[i+1][j].F3p / g[i+1][j].F1p),2) + g[i+1][j].F2p - pow(g[i+1][j].F1p,2)/g[i+1][j].rhop;
	g[i+1][j].G4p = (gamma/(gamma-1)) * (g[i+1][j].F2p - pow(g[i+1][j].F1p,2) / g[i+1][j].rhop) * (g[i+1][j].F3p/g[i+1][j].F1p);
	g[i+1][j].G4p += (g[i+1][j].rhop/2.0f) * (g[i+1][j].F3p / g[i+1][j].F1p) * (pow(g[i+1][j].F1p/g[i+1][j].rhop,2)+pow(g[i+1][j].F3p/g[i+1][j].F1p,2));
}


// 8.43 a-d
// 
//
// calculate predicted values of df/dksi
// calculate predicted pressure

void corrector_step_1(double x,int i,int j,double dmi,double dk)
{

	// first check for boundary j=1, for j==NY calculated normally

	if(j==1)
	{
		g[i+1][j].dF1dkp = g[i][j].dmidx * (g[i+1][j].F1p-g[i+1][j+1].F1p)/dmi + (1.0f/h(x)) * (g[i+1][j].G1p-g[i+1][j+1].G1p)/dmi;
		g[i+1][j].dF2dkp = g[i][j].dmidx * (g[i+1][j].F2p-g[i+1][j+1].F2p)/dmi + (1.0f/h(x)) * (g[i+1][j].G2p-g[i+1][j+1].G2p)/dmi;
		g[i+1][j].dF3dkp = g[i][j].dmidx * (g[i+1][j].F3p-g[i+1][j+1].F3p)/dmi + (1.0f/h(x)) * (g[i+1][j].G3p-g[i+1][j+1].G3p)/dmi;
		g[i+1][j].dF4dkp = g[i][j].dmidx * (g[i+1][j].F4p-g[i+1][j+1].F4p)/dmi + (1.0f/h(x)) * (g[i+1][j].G4p-g[i+1][j+1].G4p)/dmi;
	}
	else
	{
		g[i+1][j].dF1dkp = g[i][j].dmidx * (g[i+1][j-1].F1p-g[i+1][j].F1p)/dmi+(1.0f/h(x)) * (g[i+1][j-1].G1p-g[i+1][j].G1p)/dmi;
		g[i+1][j].dF2dkp = g[i][j].dmidx * (g[i+1][j-1].F2p-g[i+1][j].F2p)/dmi+(1.0f/h(x)) * (g[i+1][j-1].G2p-g[i+1][j].G2p)/dmi;
		g[i+1][j].dF3dkp = g[i][j].dmidx * (g[i+1][j-1].F3p-g[i+1][j].F3p)/dmi+(1.0f/h(x)) * (g[i+1][j-1].G3p-g[i+1][j].G3p)/dmi;
		g[i+1][j].dF4dkp = g[i][j].dmidx * (g[i+1][j-1].F4p-g[i+1][j].F4p)/dmi+(1.0f/h(x)) * (g[i+1][j-1].G4p-g[i+1][j].G4p)/dmi;
	}


	//
	// 8.16 (without u, because it is not given)
	//
	//
	// calculate predicted pressure Pp[i+1][j-1], Pp[i+1][j], Pp[i+1][j+1]	(loop)
	//

	g[i+1][j].pp=g[i+1][j].F2p-(pow(g[i+1][j].F1p,2)/g[i+1][j].rhop);
}


// 8.44 a-d
//
//
// finally calculations with boundary conditions!
//

void corrector_step_2(int i,int j,double dk)
{

	if(j==1 || j==NY)
	{

		g[i+1][j].dF1dkav = 0.5 * (g[i][j].dF1dk + g[i+1][j].dF1dkp);
		g[i+1][j].dF2dkav = 0.5 * (g[i][j].dF2dk + g[i+1][j].dF2dkp);
		g[i+1][j].dF3dkav = 0.5 * (g[i][j].dF3dk + g[i+1][j].dF3dkp);
		g[i+1][j].dF4dkav = 0.5 * (g[i][j].dF4dk + g[i+1][j].dF4dkp);

		g[i+1][j].F1 = g[i][j].F1 + g[i+1][j].dF1dkav * dk;
		g[i+1][j].F2 = g[i][j].F2 + g[i+1][j].dF2dkav * dk;
		g[i+1][j].F3 = g[i][j].F3 + g[i+1][j].dF3dkav * dk;
		g[i+1][j].F4 = g[i][j].F4 + g[i+1][j].dF4dkav * dk;

	}
	else
	{
		g[i+1][j].dF1dkav = 0.5 * (g[i][j].dF1dk + g[i+1][j].dF1dkp);
		g[i+1][j].dF2dkav = 0.5 * (g[i][j].dF2dk + g[i+1][j].dF2dkp);
		g[i+1][j].dF3dkav = 0.5 * (g[i][j].dF3dk + g[i+1][j].dF3dkp);
		g[i+1][j].dF4dkav = 0.5 * (g[i][j].dF4dk + g[i+1][j].dF4dkp);

		g[i][j].SF1p = (Cy*fabs( g[i+1][j+1].pp - 2*g[i+1][j].pp + g[i+1][j-1].pp) / (g[i+1][j+1].pp + 2*g[i+1][j].pp + g[i+1][j-1].pp)) * (g[i+1][j+1].F1p - 2*g[i+1][j].F1p + g[i+1][j-1].F1p);
		g[i][j].SF2p = (Cy*fabs( g[i+1][j+1].pp - 2*g[i+1][j].pp + g[i+1][j-1].pp) / (g[i+1][j+1].pp + 2*g[i+1][j].pp + g[i+1][j-1].pp)) * (g[i+1][j+1].F2p - 2*g[i+1][j].F2p + g[i+1][j-1].F2p);
		g[i][j].SF3p = (Cy*fabs( g[i+1][j+1].pp - 2*g[i+1][j].pp + g[i+1][j-1].pp) / (g[i+1][j+1].pp + 2*g[i+1][j].pp + g[i+1][j-1].pp)) * (g[i+1][j+1].F3p - 2*g[i+1][j].F3p + g[i+1][j-1].F3p);
		g[i][j].SF4p = (Cy*fabs( g[i+1][j+1].pp - 2*g[i+1][j].pp + g[i+1][j-1].pp) / (g[i+1][j+1].pp + 2*g[i+1][j].pp + g[i+1][j-1].pp)) * (g[i+1][j+1].F4p - 2*g[i+1][j].F4p + g[i+1][j-1].F4p);

		g[i+1][j].F1 = g[i][j].F1 + g[i+1][j].dF1dkav * dk + g[i+1][j].SF1p;
		g[i+1][j].F2 = g[i][j].F2 + g[i+1][j].dF2dkav * dk + g[i+1][j].SF2p;
		g[i+1][j].F3 = g[i][j].F3 + g[i+1][j].dF3dkav * dk + g[i+1][j].SF3p;
		g[i+1][j].F4 = g[i][j].F4 + g[i+1][j].dF4dkav * dk + g[i+1][j].SF4p;
	}

}


// 8.8 - 8.12, page 380
//
//
// decode values of physical quantities
//

void corrector_encode_physcis(int i, int j)
{
	double A,B,C;
	
	// 8.8 - 8.12, page 380
	//
	//
	// decode values of physical quantities
	//

	A=pow(g[i+1][j].F3,2) / (2.0f*g[i+1][j].F1) - g[i+1][j].F4;
	B=(gamma/(gamma-1)) * g[i+1][j].F1 * g[i+1][j].F2;
	C=-((gamma+1)/(2*gamma-2)) * pow(g[i+1][j].F1,3);

	g[i+1][j].rho = (-B + sqrt(pow(B,2)-4*A*C)) / (2*A);


	g[i+1][j].u = g[i+1][j].F1 / g[i+1][j].rho;
	g[i+1][j].v = g[i+1][j].F3 / g[i+1][j].F1;
	g[i+1][j].p = g[i+1][j].F2 - g[i+1][j].F1 * g[i+1][j].u;

	// T from state equation

	g[i+1][j].t = g[i+1][j].p / (M_R * g[i+1][j].rho);
	
	// Mach number
	g[i+1][j].m = sqrt( pow(g[i+1][j].u,2) + pow(g[i+1][j].v,2)) / (sqrt(gamma * M_R * g[i+1][j].t));

	// miu angle
	g[i+1][j].miu=RTD*(asin(1.0f/g[i+1][j].m));

	// 8.13 - 8.18
	//
	// Calculate G[][] values for next [i] point, directlyu from calculated F[][] values

	g[i+1][j].G1 = g[i+1][j].rho*(g[i+1][j].F3/g[i+1][j].F1);
	g[i+1][j].G2 = g[i+1][j].F3;
	g[i+1][j].G3 = g[i+1][j].rho * pow(g[i+1][j].F3 / g[i+1][j].F1,2) + g[i+1][j].F2 - pow(g[i+1][j].F1,2)/g[i+1][j].rho;		// without P - eq. 8.17
	g[i+1][j].G4 = (gamma/(gamma-1)) * (g[i+1][j].F2-pow(g[i+1][j].F1,2)/g[i+1][j].rho) * (g[i+1][j].F3/g[i+1][j].F1);
	g[i+1][j].G4 +=(g[i+1][j].rho/2.0f) * (g[i+1][j].F3/g[i+1][j].F1) * (pow(g[i+1][j].F1/g[i+1][j].rho,2) + pow(g[i+1][j].F3/g[i+1][j].F1,2));
}



//
// Prandtl-Meyer function for Mach number calculations
//
// REMEMBER TO SET F_ACT VALUE FIRST!!!
// zero pm_f(M)

double ZeroBisekcja(double a, double b, double (*fu)(double), double eps)
{
	while((b-a)/2.0f > eps)
	{
		if((*fu)(a)*(*fu)((a+b)/2) <= 0) 
			(b = (a+b)/2); 
		else
			a = (a+b)/2;
	}

	
	return (a+b)/2.0;
}

double pm_f(double M)			// for zero calculations
{
	double f1;
	double f2;
	double f3;

	f1=sqrt((gamma+1)/(gamma-1));
	f2=RTD*atan(sqrt( ((gamma-1)/(gamma+1)) * (pow(M,2)-1) ));
	f3=-RTD*atan(sqrt(pow(M,2)-1));	

	return (f1*f2+f3-f_act);
}

double pm(double M)			// return pm function value for given M
{
	double f1;
	double f2;
	double f3;

	f1=sqrt((gamma+1)/(gamma-1));
	f2=RTD*atan(sqrt( ((gamma-1)/(gamma+1)) * (pow(M,2)-1) ));
	f3=-RTD*atan(sqrt(pow(M,2)-1));	

	return (f1*f2+f3);
}

void abbett(double x, int i)
{
	double A,B,C;
	double rhocal,Ucal,Vcal,Pcal,Tcal,Mcal;
	double phi1,fcal,fact,Mact;


	A=pow(g[i+1][1].F3,2)/(2*g[i+1][1].F1)-g[i+1][1].F4;
	B=(gamma/(gamma-1))*g[i+1][1].F1*g[i+1][1].F2;
	C=-((gamma+1)*pow(g[i+1][1].F1,3))/(2*(gamma-1));
		
	rhocal=(-B+sqrt(pow(B,2)-4*A*C))/(2*A);				// corrected value of rho

	Ucal=g[i+1][1].F1/rhocal;
	Vcal=g[i+1][1].F3/g[i+1][1].F1;
	Pcal=g[i+1][1].F2-g[i+1][1].F1*Ucal;

	// T from state equation

	Tcal=Pcal/(M_R*rhocal);

	if(x<M_E)			// before expansion corner
	{
		phi1=RTD*atan((Vcal/Ucal));
	}
	else			// behind expansion corner
	{
		phi1=mtheta-RTD*atan(fabs(Vcal)/Ucal);			// there Phi1====Phi2 (notation change)
	}


									// J.Svenss. a=sqrt(gamma*R*T).
	Mcal=sqrt(pow(Ucal,2)+pow(Vcal,2))/(sqrt(fabs(gamma*M_R*Tcal)));

	////cout << endl << endl << "rhocal:  " << rhocal <<  "gamma:  " << gamma << "  M_R:  " << M_R << "  Tcal: " << Tcal << endl << endl;
	////cout << endl << " (sqrt(gamma*M_R*Tcal)): " << (sqrt(gamma*M_R*Tcal)) << endl;


	fcal=pm(Mcal);
	fact=fcal+phi1;
	f_act=fact;											// for bisection pm_f function


	// now obtain Mach number after rotation

//	f_act=fact=31.57;
	//Mact=ZeroBisekcja(0,10,pm_f,0.0000001);

	
	////cout << " Mcal: " << Mcal << " Pcal: " << Pcal << " Vcal: " << Vcal << " Ucal: " << Ucal << " Phi1: " << phi1 << " Mcal: " << Mcal << " fact:  " << f_act << endl;

//	Mact=FindZero(1.1,pm_f,0.00001);			
	Mact=ZeroBisekcja(1.1,3,pm_f,0.000000000000001);


	//cout << endl << endl << endl << "Mact:  " << Mact << endl << endl;

	//printf("%f\n",Mact);



	// finally calculations for j=1 point
	g[i+1][1].p=Pcal*pow( (1+((gamma-1)/2)*pow(Mcal,2))/(1+((gamma-1)/2)*pow(Mact,2)), gamma/(gamma-1) );	// Pact
	g[i+1][1].t=Tcal*( (1+((gamma-1)/2)*pow(Mcal,2))/(1+((gamma-1)/2)*pow(Mact,2)) );
	g[i+1][1].rho=g[i+1][1].p/(M_R*g[i+1][1].t);
	g[i+1][1].u=Ucal;
//	g[i+1][1].v=-g[i+1][1].u * tan(DTR*mtheta);
	
	if(x>M_E)
		g[i+1][1].v=-g[i+1][1].u * tan(DTR*mtheta);
	else
		g[i+1][1].v=0;
		
	g[i+1][1].m=Mact;
	g[i+1][1].miu=RTD*(asin(1.0f/g[i+1][1].m));
		
	g[i+1][1].F1 = g[i+1][1].rho * g[i+1][1].u;
	g[i+1][1].F2 = g[i+1][1].rho * pow(g[i+1][1].u,2) + g[i+1][1].p;
	g[i+1][1].F3 = g[i+1][1].rho * g[i+1][1].u * g[i+1][1].v;
	g[i+1][1].F4 = g[i+1][1].rho * g[i+1][1].u * (pow(g[i+1][1].u,2) + pow(g[i+1][1].v,2))/2 + (gamma/(gamma-1)) * g[i+1][1].p * g[i+1][1].u;

/*	g[i+1][1].G1=g[i+1][1].rho*(g[i+1][1].F3/g[i+1][1].F1);
	g[i+1][1].G2=g[i+1][1].F3;
	g[i+1][1].G3=g[i+1][1].rho*pow(g[i+1][1].F3/g[i+1][1].F1,2)+g[i+1][1].F2-pow(g[i+1][1].F1,2)/g[i+1][1].rho;		// without P - eq. 8.17
	g[i+1][1].G4=(gamma/(gamma-1))*(g[i+1][1].F2-pow(g[i+1][1].F1,2)/g[i+1][1].rho)*(g[i+1][1].F3/g[i+1][1].F1);
	g[i+1][1].G4+=(g[i+1][1].rho/2.0f)*(g[i+1][1].F3/g[i+1][1].F1)*(pow(g[i+1][1].F1/g[i+1][1].rho,2)+pow(g[i+1][1].F3/g[i+1][1].F1,2));
*/
	g[i+1][1].G1=g[i+1][1].rho*g[i+1][1].v;
	g[i+1][1].G2=g[i+1][1].rho*g[i+1][1].v*g[i+1][1].u;
	g[i+1][1].G3=g[i+1][1].rho*pow(g[i+1][1].v,2)+g[i+1][1].p;
	g[i+1][1].G4=g[i+1][1].rho*g[i+1][1].v*(pow(g[i+1][1].u,2)+pow(g[i+1][1].v,2))/2.0f + (gamma/(gamma-1))*g[i+1][1].p*g[i+1][1].v;
	
}
